package edu.berkeley.sbp.misc;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.Token.Location;
import edu.berkeley.sbp.util.*;

public class CharToStringParser extends Parser<CharToken,String> {
    public CharToStringParser(Union u) { super(u, new IntegerTopology<CharToken>()); }
    public Forest<String> parse(InputStream is) throws IOException, ParseFailed {
        return super.parse(new CharToken.Stream(is));
    }
    public Forest<String> parse(Reader r) throws IOException, ParseFailed {
        return super.parse(new CharToken.Stream(r));
    }
    public Forest<String> shiftToken(CharToken ct, Location loc) {
        return Forest.create(loc, ct.result(), null, false, false);
    }
}
